#include <cstdlib>
#include <fstream>
#include <iostream>

#include "gcsa.h"
#include "graph.h"

#include <misc/utils.h>


using namespace CSA;


int
main(int argc, char** argv)
{
  std::cout << "Index builder" << std::endl;
  std::cout << std::endl;
  if(argc < 4)
  {
    std::cout << "Usage: build_index node_file edge_file output" << std::endl;
    return 1;
  }

  std::string node_name(argv[1]);
  std::cout << "Nodes:  " << node_name << std::endl;
  std::string edge_name(argv[2]);
  std::cout << "Edges:  " << edge_name << std::endl;
  std::string output_name(argv[3]);
  std::cout << "Output: " << output_name << std::endl;
  std::cout << std::endl;

  Graph graph(node_name, edge_name, true);
  if(graph.node_count == 0 || graph.edge_count == 0) { return 3; }
  PathGraph* pg = graph.getLastGeneration(true);
  if(pg == 0)
  {
    std::cerr << "Error: No PathGraph exists!" << std::endl;
    return 2;
  }

/*
  graph.setIds();
  for(usint i = 1; i < pg->node_count; i++)
  {
    if(pg->nodes[i]->first == pg->nodes[i - 1]->first)
    {
      std::cout << "Node " << i << ", label " << pg->nodes[i]->first << std::endl;
      std::cout << "Sorted: (" << pg->nodes[i]->sorted << ", " << pg->nodes[i-1]->sorted  << ")" << std::endl;
      std::cout << "  from (label " << pg->nodes[i]->from->label
                << ", id " << pg->nodes[i]->from->outdegree
                << ", value " << pg->nodes[i]->from->value
                << ") to (label " << pg->nodes[i]->to->label
                << ", id " << pg->nodes[i]->to->outdegree
                << ", value " << pg->nodes[i]->to->value
                << ")" << std::endl;
      std::cout << "  from (label " << pg->nodes[i-1]->from->label
                << ", id " << pg->nodes[i-1]->from->outdegree
                << ", value " << pg->nodes[i-1]->from->value
                << ") to (label " << pg->nodes[i-1]->to->label
                << ", id " << pg->nodes[i-1]->to->outdegree
                << ", value " << pg->nodes[i-1]->to->value
                << ")" << std::endl;
      std::cout << std::endl;
    }
  }
  graph.clearIds();
*/

  GCSA gcsa(*pg, true);
  delete pg;
  gcsa.writeTo(output_name);

  return 0;
}
