#include <cstdlib>
#include <fstream>
#include <iostream>

#include "graph.h"
#include <misc/utils.h>


using namespace CSA;


int
main(int argc, char** argv)
{
  std::cout << "Path length doubler" << std::endl;
  std::cout << std::endl;
  if(argc < 3)
  {
    std::cout << "Usage: double_paths node_file edge_file" << std::endl;
    return 1;
  }

  std::string node_name(argv[1]);
  std::cout << "Nodes: " << node_name << std::endl;
  std::string edge_name(argv[2]);
  std::cout << "Edges: " << edge_name << std::endl;

  Graph graph(node_name, edge_name, true);
  if(graph.node_count == 0 || graph.edge_count == 0) { return 2; }
  std::cout << std::endl;

  bool sorted = doublePaths(graph);
  std::cout << "The paths are ";
  if(!sorted) { std::cout << "NOT "; }
  std::cout << "sorted." << std::endl;
  std::cout << std::endl;

  return 0;
}
